/*
 * basic.c
 *
 * Created: 2014-10-21 10:51:54
 *  Author: dsosnowski
 */ 


//---------------------------------------
//includes
#define F_CPU 9600000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <avr/sleep.h>
//#include <avr/pgmspace.h>
#include "defs.h"
#include "basic.h"

struct {
	char led;
	char out;
	
} ui;


//-------------------------------------------------
char LedSet(char action)
{
	if (action == LED_SET) 
	{
		PORTB &= ~(1<<LED_PIN);
		ui.led = 1;
	}
	if (action == LED_OFF) 
	{
		PORTB |=  (1<<LED_PIN);
		ui.led = 0;
	}
	return ui.led;
}


//-------------------------------------------------
char OutSet(char action)
{
	if (action == OUT_SET)
	{
		PORTB |=  (1<<OUT_PIN);
		ui.out = 1;
	}
	if (action == OUT_OFF)
	{
		PORTB &= ~(1<<OUT_PIN);
		ui.out = 0;
	}
	return ui.out;
}

//-------------------------------------------------
char GetReg(void)
{	
	uint16_t temp;
	
	ADMUX = (1);
	ADCSRA |= (1<<ADEN | 1<<ADPS2 | 1<<ADPS1 | 1<<ADPS0);
	ADCSRA |= (1<<ADSC);			
	
	while (ADCSRA & (1<<ADSC));	//wait for conv complite
	temp = ADC;
	ADCSRA &= ~(1<<ADEN);			//turn off
	
	temp /= 10;
	if (temp > 100) temp = 100;
	temp = (100 - temp);
	return (uint8_t)temp;					//return val
}	
	