/*
 * humm_ek.c
 *
 * Created: 2014-10-21 10:43:46
 *  Author: dsosnowski
 */ 


//---------------------------------------
//includes
#define F_CPU 9600000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <avr/sleep.h>
//#include <avr/pgmspace.h>
#include "defs.h"
#include "basic.h"
#include "wdog.h"
#include "dht.h"
//#include "s_uart.h"


//-------------------------------------------------
void HardInit(void);


extern struct {
	int16_t humdity;
	int16_t temperature;
	uint16_t hdata;
	uint16_t tdata;
	char check;
	char status;
} dht;

struct {
	char hval;
	char reg;
	char status;
	char loop;
	char state;
	char action;
	char manual;
	char press;
	char dis_h;
	char dis_l;
} system;




//-------------------------------------------------
int main(void)
{
	HardInit();	
	//SuartInit();
	//sei();
	while(1)
	{

		//--------------------------------------------------
		system.loop++;
		if (system.loop >= MAIN_PERIOD)
		{
			system.loop = 0;
			system.status = 0;
			
			if (DHTRead() == DHT_READY)		//read data
			{
				if (DHTStatusGet() == DHT_READY)		//check crc
				{
					DHTHumidityGet();
					system.hval = (uint8_t)(dht.humdity);
					system.reg = GetReg();
					if (system.reg < 3) system.reg = 3;
					
					if (system.hval >= system.reg)
					{
						if (system.dis_h == 0) system.action = 1;
					} 
					
					//else
					if (system.hval <= system.reg - 3)
					{
						if (system.dis_l == 0) system.action = 2;
					}
					
					system.status = 1;
				}
			}			
		}

		//--------------------------------------------------
		if (system.action)
		{
			if (system.action == 1)
			{
				system.state = 1;
				system.dis_h = 1;
				system.dis_l = 0;
			}
			if (system.action == 2)
			{
				system.state = 0;
				system.dis_h = 0;
				system.dis_l = 1;
			}
			system.action = 0;
		}
	
		//--------------------------------------------------
		if ((PINB & (1<<SW_PIN)) == 0)
		{
			if (system.press < 0xFF) system.press++;
		}
		else
			system.press = 0;
		
		if (system.press == 5)
		{
			system.loop = 0;
			if (system.state == 1)
				system.state = 0;
			else
				system.state = 1;
		}		

		//--------------------------------------------------		
		if (system.state == 1)
			OutSet(OUT_SET);			
		else
			OutSet(OUT_OFF);
		
		//--------------------------------------------------
		if (system.status == 1)
		{
			if (OutSet(0) == 0)
			{
				if (system.loop < 3) LedSet(LED_SET);
				if (system.loop == 3) LedSet(LED_OFF);
			}
			else
			{
				if (system.loop < 3) LedSet(LED_OFF);
				if (system.loop == 3) LedSet(LED_SET);
			}
		}
		else
		{
			if (system.loop & 2) 
				LedSet(LED_SET);
			else
				LedSet(LED_OFF);			
		}
		
		//--------------------------------------------------
		_delay_ms(MAIN_DELAY);
		wdt_reset();		
	}
}

//-------------------------------------------------
void HardInit(void)
{
	PORTB = 0;
	DDRB =  (1<<OUT_PIN | 1<<LED_PIN);
	
	ACSR = (1<<ACD);
	
	WdtSet(7);
}
